<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | gxBoard                                                              |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 gxBoard.co.kr                                     |
// +----------------------------------------------------------------------+
// | This source file is subject to The gxBoard License,                  |
// | that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at                           |
// | http://gxboard.co.kr/license/LICENSE.txt.                            |
// | If you did not receive a copy of the gxBoard license and are unable  |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@gxboard.co.kr so we can mail you a copy immediately.         |
// +----------------------------------------------------------------------+
// | Author: Kiwha Um <xhunter@gxboard.co.kr>                             |
// +----------------------------------------------------------------------+
//
// $Id: gxBoard.php,v 1.1b 2002/11/28 3:13:53  xhunter Exp $



require_once ( 'HTML/IT.php') ;
require_once ( 'gx/lib/gxfunctions.php');
require_once ( 'gx/board/gxBoard.lib.php');
require_once ( 'gx/board/gxBoard_require.php');




#mode=config
{


	$boardcfg[dir_tmpl]   = ($boardcfg[dir_tmpl]  =="") ? $gx_ini['skin_root']."/default" : $boardcfg[dir_tmpl] ;
	$boardcfg[url_images] = ($boardcfg[url_images]=="") ? $gx_ini['skin_root_url_images'].$boardcfg[dir_tmpl]."/images" : $boardcfg[url_images] ; 

	if( $boardcfg[page_term] ) { 	$page_term = $boardcfg[page_term] ; 	}
	if( $boardcfg[abbr_size] ) {	$abbr_size = $boardcfg[abbr_size] ; 	}

	$tmpl_html = $boardcfg ; 
	$tmpl_html[images] = $boardcfg[url_images] ; 

	if( !isset($boardcfg[use_ini])  ) {

	} elseif( $boardcfg[use_ini] > 0 ) {
		$board_ini_file_dir = is_dir($boardcfg[dir_tmpl]) ? $boardcfg[dir_tmpl] : "$gxConfig[gxpath]/$boardcfg[dir_tmpl]" ; 
		$board_ini_file = is_file($board_ini_file_dir."/gxBoard.ini") ? $board_ini_file_dir."/gxBoard.ini" : "" ;

	} else {
		unset($board_ini_file) ;

	}
	
	if( $board_ini_file ) {


		if( $ini_array = @parse_ini_file($board_ini_file,true) ) {
		} else {
			$ini_array = parse_ini_file($gxConfig[gxpath]."/".$board_ini_file,true) ; 
		}

		$ini_array = gxDecode($ini_array) ; 

		$btn = cfgtr($ini_array[btn],$tmpl_html[images]);
		$LI = cfgtr($ini_array[LI],$tmpl_html[images]);

		if( !$page_term && $ini_array[page_term] !== ""  ) {
			$page_term = $ini_array[page_term];
		} 
		if( !$abbr_size && $ini_array[abbr_size] !== "" ) {
			$abbr_size = $ini_array[abbr_size];
		} 
	} 

	if( $boardcfg[grant_table] ) {
		$gxGRANT = gxGrant($_SESSION[sess_auth],$grant_mode_board_keys,$boardcfg[grant_table],$boardcfg[admin],$_SESSION[sess_user_id] );
	}


	$page_term = isset($page_term) ? $page_term : 10 ; 

	if( is_array($boardcfg) ) {
		$gxConfig[activeBoardCategory] = ( $boardcfg[use_category] == 1 )   ? true : false ;
		$gxConfig[activeFileUpload]    = ( $boardcfg[use_fileupload] == 1 ) ? true : false ;
		$gxConfig[pwdelete]			   = ( isset($boardcfg[password]) ) ? $boardcfg[password] : $gxConfig[pwdelete] ;

	}

	$gxConfig[activeBoardCategory] = 0 ; 
	if( $gxConfig[activeBoardCategory] ) {

		include_once ( "gx/lib/gxfnc_category.php");
		$htmCategorySelect = gxCategory($htmCategoryPath,$category_options,$arrCategory,$category_id);
	}

	#print_r( array_keys($boardcfg) );

} //mode=config


if($submit_create_table && $table_name  ) {
	#mode=create_table_submit
	include ( 'gx/board/create_table.php');

	echo_exit() ; 

}



if ( !is_array($gxGRANT) ) {		$gxGRANT = gxGrant($_SESSION[sess_auth]);	}

#echo "<BR>board_ini_file = $board_ini_file";
#echo "<BR><pre>gxGRANT : " ; print_r($gxGRANT); echo "</pre>";


$tbl_name = isset($tbl_name) ? $tbl_name : "gxboard" ;
$tbl_name_category = $tbl_name."_category";
$tbl_name_count = $tbl_name."_count";


	#echo "$gx_ini[skin]/tmpl";
	if( $boardcfg['dir_tmpl'] ) {
		$tmpl_dir = $boardcfg['dir_tmpl']."/tmpl" ; 
	} else {
		$tmpl_dir = isset($gx_ini['skin']) ? $gx_ini['skin']."/tmpl" : $gx_ini['skin_root']."/default/tmpl";
	}

	$tmpl_dir = is_dir($tmpl_dir) ? $tmpl_dir : "$gxConfig[gxpath]/$tmpl_dir" ; 
	$tmpl = new IntegratedTemplate($tmpl_dir);
	$tmpl->setVariable($boardcfg);



	#mode=copyright
	echo "
<a href=\"http://gxboard.co.kr\">
<!-- Please visit gxboard Community of Open Source Software Project -->
<!-- +----------------------------------------------------------------------+ -->
<!-- | gxBoard                                                              | -->
<!-- +----------------------------------------------------------------------+ -->
<!-- | Copyright (c) 2002 gxBoard.co.kr                                     | -->
<!-- +----------------------------------------------------------------------+ -->
<!-- | gxBoard is a web based application suite(OSS).                       | -->
<!-- | Based on PHP, programming language module for the Apache             | -->
<!-- | or IIS,The backend database is MySQL                                 | -->
<!-- | Source for FREE!                                                     | -->
<!-- | available at through the world-wide-web at www.gxboard.co.kr         | -->
<!-- +----------------------------------------------------------------------+ -->
<!-- | Author: Kiwha Um <xhunter@gxboard.co.kr>                             | -->
<!-- +----------------------------------------------------------------------+ -->
</a>
";
if( $sess_uid == 1 ) {
echo "
<!--#gxComment

	\$board_ini_file  = $board_ini_file
	IT::Template Root = {$tmpl->fileRoot}	

//gxComment -->\n";
}






$dTag = array("BLOCKQUOTE","TEXTAREA","TABLE");









	# ٸ    (  input-hidden  rand . )
	$validate_post = 0 ; 
	if ( ereg("^http://$HTTP_HOST$PHP_SELF",$HTTP_REFERER) 
	and $_SESSION['md5_rand'] == $CERTIFICATION_KEY 
	and $CERTIFICATION_KEY !=="" ) {
	
		$validate_post = 1 ; 
	} else {
		$post_error[] = " ϴ.(ڵ۵ α׷ !)";
		
	}

	#   ߺ ۼ . 



	if ( $vid > 0 ) {
		$page = floor( $vid / $page_term )   ; 
	}


if ( $submit ) {
	#mode=submit

	gxUnAuthorized($sess_auth,"submit");

	#ٸȣƮ  

	#(ߺۼ)
	#ڿּҰ
	#ʼ׸üũ


	if( gxAuth( $sess_auth ,$mode ) ) {
		
	} else {
			$post_error[] = " ϴ.";
		
	}

		if( $user_pass == "" ) {
			$user_pass = substr(microtime(),3,6) ;
			$alert_pass = "йȣ Է \\nڵ йȣ Ǿϴ. \\n\\n Խù йȣ $user_pass Դϴ. \\n";
		}


	# ( /йȣ,̵ġ )
	if ( $bid > 0 && $mode != "reply" ) {
		$insert_bid = $bid ; 



		if ( gxAuth( $sess_auth ,"admin" ) ) {
		} else {

			$where_user_pass = " and user_pass=password('$pwmodify')";
			#$post_error[] = "йȣ ġ  ʽϴ.";
		
		}


	
	} else {
		$rs_ib = mysql_query("select MAX(bid)+1 from $tbl_name ") ; 
		$insert_bid =  mysql_result($rs_ib,0,0); 


	}



$wi = 0 ; 
while( $wi < count($contents) ) {
//*
	$countTag = array(); 
	$countTag = gxCountTag( $contents[$wi] ); 
	#print_r($countTag) ; 
	$startTag = "";
	$endTag = "";
	foreach( $dTag as $i=>$e_tag) {

			$compTagTable = 	$countTag["$e_tag"] -	$countTag["/$e_tag"] ;
			if( $compTagTable < 0  ) {
					if( $e_tag =="TABLE") {
						$e_tag = "TABLE><TR><TD";
					}
				$startTag = str_repeat("<$e_tag>",abs($compTagTable) ) . $startTag ;
			} elseif( $compTagTable > 0 ) {
				$endTag .= str_repeat("</$e_tag>",$compTagTable);
			} else {
				
			}

	}
// */
	$contents[$wi] = $startTag.$contents[$wi].$endTag ; 
	$contents[$wi] = trim($contents[$wi]) ; 
	$wi++ ; 
}

	if( ereg("߰|add",$submit)) {
		$contents[$wi] = " ";
		$attach[$wi] = "";
		$mode_apply = "mode=write&user_pass=$user_pass";
	}

	#function gxMultiFileUpload($attach,$attach_name,$previous,$tbl_name,$aid,$dir="upload") 
	#Ͼε
	if( $gxConfig[activeFileUpload] ) {
			$update_attach = gxMultiFileUpload($attach,$attach_name,$prev_attach,$tbl_name,$insert_bid) ; 
			$update_attach = " attach='$update_attach' , " ; 
	}

	$contents = implode("<!-- -->",$contents) ; 

	$countTag = gxCountTag( $contents ); 
	if( $countTag[TABLE] > 1 or $countTag[BR] > 10 ) {
	} else {

		ereg_replace("{([[:alpha:]]*)}","{<q>\\1</q>}",$contents) ; 		
		$contents = ereg_replace("\n","<br>",$contents) ; 
		$contents = ereg_replace("\r","",$contents) ; 
		
	}

	if( $Subject =="") {
		$Subject = "";
	}

#####################################
#echo "$boardcfg[board_name],$boardcfg[admin],$boardcfg[admin_mail]";

		$tmplVar['contents'] = $contents;
		$tmplVar['Subject'] = $Subject;
		$tmplVar['subject'] = $Subject;
		$tmplVar['Date'] = $Date;
		$tmplVar['date'] = $Date;
		$tmplVar['user_alias'] = $user_name;
		$tmplVar['name'] = $user_name;
		$tmplVar['user_id'] = $user_id;
		$tmplVar['id'] = $user_id;
		$tmplVar['tab'] = $tbl_name;
		$tmplVar['tbl_name'] = $tbl_name;
		$tmplVar['bid'] = $bid;
		$tmplVar['HTTP_HOST'] = $HTTP_HOST;
		$tmplVar['PHP_SELF'] = $PHP_SELF;
		if( is_array($attach_name) ) {
			$tmplVar['attach'] = "<br>".implode("<BR>",$attach_name);
		}

		$mailto_admin = "\"{$boardcfg[admin]}\"<{$boardcfg[admin_mail]}>";
		$mail_subject = "{$boardcfg[board_name]} $Subject [ $mode $bid ]";
		$from = "\"$user_name($user_id)\" <$user_email>";
		#	$replyto = "\"$replyto\"<$replyto>"; // 



		$tmpl->loadTemplatefile("sendmail_board.htm", true, true);
		if( $tmpl->blocklist[sendmail_board] ) {

			$tmpl->setCurrentBlock("sendmail_board") ;
			$tmpl->setVariable($tmplVar) ;
			$tmpl->setVariable($boardcfg) ;
			$tmpl->parseCurrentBlock("sendmail_board") ;
			$mail_body = $tmpl->get() ; 	
			$fnSendMail = "gxSendMail";
			if( $boardcfg[admin_mail] ) {
				gxSendMail($mailto_admin,$mail_subject,$mail_body,$from);
			}
		} else {

			$fnSendMail = "mail";
			$from = "From: $from"; // ȸ,,Ϸ
			$textContents = ereg_replace("<br>","\n",$contents);
			$mail_body = "
Subject: $Subject
Date: $Date
Writer: $user_name($user_id)
==============================================

$textContents

==============================================

Խù ٷΰ : http://$HTTP_HOST$PHP_SELF?bid=$bid 

Powered by http://www.gxboard.co.kr
";  //   κ

			$it_fail = "\n\nø  ġ : {$tmpl->fileRoot}{$tmpl->lastTemplatefile}\n";

			if( $boardcfg[admin_mail] ) {
				mail($mailto_admin,$mail_subject,$mail_body.$it_fail,$from);
			}
		}

#print_r($_POST);
#exit();
#####################################


	if( is_array($post_error )) {

		print_r($post_error) ; 
		echo_exit() ; 
		
	} 

	if( $category_id ) {
		$update_category_id = "category_id='$category_id',";
	}
	

	if ( $bid > 0 && $mode != "reply" ) {

		$st_write = "update $tbl_name set
			ref_bid='$ref_bid',
			$update_category_id
			Subject='$Subject',
			user_name='$user_name',
			user_email='$user_email',
			user_id='$user_id',
			user_pass=password('$user_pass'),
			user_agent='$HTTP_USER_AGENT',
			remote_addr='$REMOTE_ADDR',
			hostname='$HTTP_HOST',
			lastModified=now(),
			$update_attach
			contents='$contents'
			WHERE bid=$bid and lastModified='$lastModified' $where_user_pass
		";
#			Date=now(),
#			lastReply=now(),



	} else {


		if ($mode=="reply") {
			$ref_bid_a = ref_split($ref_bid);
			$where_lastReply = "WHERE bid rlike '^". implode("$|^",$ref_bid_a) . "$'";
			$st_reply = "update $tbl_name set lastReply=now() ".$where_lastReply ;

			#echo $replyto , $fnSendMail ; 
			if( $replyto  ) {
				$fnSendMail($replyto,$mail_subject,$mail_body,$from);
			}
			#exit();

		} else {
		}


		$st_write = "insert into $tbl_name set
			ref_bid='$ref_bid',
			$update_category_id
			Subject='$Subject',
			Date=now(),
			lastModified=now(),
			user_name='$user_name',
			user_email='$user_email',
			user_id='$user_id',
			user_pass=password('$user_pass'),
			user_agent='$HTTP_USER_AGENT',
			remote_addr='$REMOTE_ADDR',
			hostname='$HTTP_HOST',
			lastReply=now(),
			$update_attach
			contents='$contents'
		";


	
	}


	if ( $rs = mysql_query($st_write) ) {

		if ( $bid > 0 ) {
			$get_vars[vid] = "vid=$vid";
			if( mysql_affected_rows() == 0 ) {
				echo_replace("$PHP_SELF?{$gVtab}bid=$bid","!\\n\\nԽù  ʰų\\nйȣ(Ͻ) ġ  ʽϴ.");
			}
		} else {
			$bid = mysql_insert_id();
			mysql_query("insert into $tbl_name_count set bid=$bid , last=now() , remote_ip='$REMOTE_ADDR' , access_user='$sess_user_id'");
		}

		if( $mode=="reply" && isset($st_reply)) {
			if( mysql_query($st_reply) ) {
				
			} else {
				echo($st_reply);
				echo mysql_error(); 
				exit();
			}
			
		}

		if( $mode_apply ) {
			$get_vars[mode_apply] = $mode_apply ; 
		}
		#$get_vars[] = "{$gVtab}bid=$bid";
		$continue = implode('&',$get_vars) ; 

		echo_replace("$PHP_SELF?bid=$bid&$continue",$alert_pass) ; 

	
	} else {
		echo 	mysql_error();
		echo_exit() ; 
	
	}
	


} //mode=submit


	#print_r($LI);

#mode=script
{
?>


<style>
	li { list-style-image: url('<?=$LI[transparency]?>') }
</style>

<script language="JavaScript1.2" >
<!-- 
	function chcollapsed(srcImage) {
			var re = new RegExp("<?=$LI[srcExpand]?>");
			srcImage.src = re.test(srcImage.src) ? "<?=$LI[srcReduce]?>" : "<?=$LI[srcExpand]?>" 
		
	}
// -->
</script>

<script language="JavaScript1.2" fptype="dynamicoutline" for="document" event="onreadystatechange()">
<!--
	initOutline()
// -->
</script>

<script language="JavaScript1.2" >
<!--
// See KB article about changing this dynamic HTML
	function getControlTag(src)
	{
		TRok = false
		while ("HTML" != src.tagName)
		{
			if ("IMG" == src.tagName || "FONT" == src.tagName || "A" == src.tagName || "TD" == src.tagName || "TR" == src.tagName )
			    TRok = true
			if ("LI" == src.tagName)
				return src
			if ("TR" == src.tagName)
			{
				if(TRok)
					return src
				return null
			}
			src = src.parentElement
		}
		return null
	}
	function dynOutlineEnabled(src)
	{
		while ("BODY" != src.tagName)
		{
			table = "TABLE" == src.tagName;
			if(table && src.getAttribute("border", false) != "0")
				return false;
			if("OL" == src.tagName || "UL" == src.tagName || table)
			{
				if(null != src.getAttribute("nodynamicoutline", false))
					return false
				if(null != src.getAttribute("dynamicoutline", false))
					return true
				if(mac > 0)
				{
					var at = src.outerHTML.indexOf("dynamicoutline")
					if(at > 0)
					{
						var gt = src.outerHTML.indexOf(">")
						if(at < gt)
							return true
					}
				}
			}
			src = src.parentElement
		}
		return false
	}
    function initCollapse(src)
    {
		while ("BODY" != src.tagName)
		{
			table = "TABLE" == src.tagName;
    		if(table && src.getAttribute("border", false) != "0")
    			return false;
        	if("OL" == src.tagName || "UL" == src.tagName || table)
    		{
    			if(null != src.getAttribute("initcollapsed", false))
    				return true
    		}
    		src = src.parentElement
        }
		return false
    }
	function containedIn(src, dest)
	{
		if ("!" == src.tagName)
			return true
		src = getControlTag(src)
		if (src == dest)
		    return true
		return false
	}
    function initOutline()
    {

		var ms = navigator.appVersion.indexOf("MSIE");
    	mac = navigator.appVersion.indexOf("Macintosh");
		ie4 = (ms>0) && (parseInt(navigator.appVersion.substring(ms+5, ms+6)) >= 4);
		if(!ie4)
			return;
        listTags = new Array()
        listTags[0]="UL"
        listTags[1]="OL"
        listTags[2]="TABLE"
        listTags[3]="TR"
        for(j=0;j<listTags.length;j++)
        {
            tagName=listTags[j]
            coll=document.all.tags(tagName)
            for(i=0; i<coll.length; i++)
            {
                if(dynOutlineEnabled(coll[i].parentElement))
                {
                    if(initCollapse(coll[i]))
                        coll[i].style.display="none"
                }
            }
        }        
    }   

    function expOutline()
    {

		var ms = navigator.appVersion.indexOf("MSIE");
    	mac = navigator.appVersion.indexOf("Macintosh");
		ie4 = (ms>0) && (parseInt(navigator.appVersion.substring(ms+5, ms+6)) >= 4);
		if(!ie4)
			return;
        listTags = new Array()
        listTags[0]="UL"
        listTags[1]="OL"
        listTags[2]="TABLE"
        listTags[3]="TR"
        for(j=0;j<listTags.length;j++)
        {
            tagName=listTags[j]
            coll=document.all.tags(tagName)
            for(i=0; i<coll.length; i++)
            {
                //if(dynOutlineEnabled(coll[i].parentElement))
                {
					if(initCollapse(coll[i])) {
							coll[i].style.display=""
					}
                }
            }
        }        
    }   



	function dynOutline(srcImage)
	{
		//var re = new RegExp("images/gx/e.gif");
		//srcImage.src = re.test(srcImage.src) ? "images/gx/r.gif" : "images/gx/e.gif"
		chcollapsed(srcImage) ; 

		var ms = navigator.appVersion.indexOf("MSIE");
		ie4 = (ms>0) && (parseInt(navigator.appVersion.substring(ms+5, ms+6)) >= 4);
		if(!ie4)
			return;
		var src = event.srcElement
		src = getControlTag(src)
		//alert(src.tagName);
		if (null == src)
			return
		if (!dynOutlineEnabled(src))
			return
		var idx = src.sourceIndex+1
		while (idx < document.all.length && containedIn(document.all[idx], src))
		{
			srcTmp = document.all[idx]
			tag = srcTmp.tagName
			if ("UL" == tag || "OL" == tag || "TABLE" == tag  )
				srcTmp.style.display = srcTmp.style.display == "none" ? "" : "none"
			idx++;
		}
	}

	var expandOutline = true ; 
	function switchOutline() {
		if( expandOutline ) {
			expOutline();
			expandOutline = false ; 
		} else {
			initOutline();
			expandOutline = true ; 
		}
		
	}

	function chsrc(obj,src) {
		obj.src = src ; 
	}


// -->
</script>


<?
} // mode=script

#mode=search
{



	if( $get_vars[tab] ) {
		$gVtab = "$get_vars[tab]&" ; 
	}


	if ($keyword) {
		$get_vars[keyword] = "keyword=$keyword";
		$where[] = "( Subject rlike '$keyword' or contents rlike '$keyword' or user_name like '$keyword%')";

	} else {

	}

	if( $parent_id > 0 ) {
			$where[] = "category_id='$parent_id' "  ; 
			$get_vars[parent_id] = "parent_id=$parent_id";
			$category_id = $parent_id ; 
	}

	if ($category_id) {
			$where[] = "category_id='$category_id' "  ; 
			$get_vars[category] = "category_id=$category_id";

	}


	if (is_array($where)) {
		foreach ($where as $key => $value ) {
			$where[$key] = stripslashes($value);
		}

		$where_clause = "WHERE ".implode(" and ",$where);
		reset($where) ; 
	}

	if ($order) {
		$get_vars[order] = "order=$order";

	} else {
		$where["order"] = "ref_bid like ''";
	
	}

	$opt_order[""] = "ORDER BY lastModified desc"; 
	$opt_order[""] = "ORDER BY bid desc "; 
	$opt_order[""] = "ORDER BY subject"; 
	$opt_order["ȸ"] = "ORDER BY view desc , bid desc"; 
	#$opt_order["õ"] = "ORDER BY recommand desc, bid desc"; 
	#$opt_order["ٿ"] = "ORDER BY download desc, bid desc"; 
	#$opt_order[""] = "ORDER BY paycount desc, bid desc"; 
	$opt_order[""] = "ORDER BY user_name , bid desc"; 
	$opt_order["ֱ"] = "ORDER BY last desc, bid desc"; 
	$opt_order[""] = "ORDER BY lastReply desc , Date desc"; 

	foreach( $opt_order as $key=>$val) {
		$order_options .= "
		<option>$key</option>"; 
		
	}

	$order_clause = $opt_order[$order];


	if ( is_array($get_vars) ) {
		$continue = implode("&",$get_vars);
	}

	$tmpl_html[tab] = $tbl_name ; 
	$tmpl_html[tbl_name] = $tbl_name ; 
	$tmpl_html[keyword] = $keyword ; 
	$tmpl_html[PHP_SELF] = $PHP_SELF ; 

	#$tmpl_html[skin] = $config[skin] ; //d/ ø   . 

	#$tmpl_html[htmCategorySelect] = $htmCategorySelect ; 
	#$tmpl_html[htmCategoryPath] = $htmCategoryPath ; 
	#$tmpl_html[category_options] = $category_options ; 

	$tmpl_html[order_options] = $order_options ; 
	$tmpl_html[select_order] = "<select name='order' onchange='submit()'>
			<option value='$order'></option>
			$order_options
			</select>";

	$tmpl_html[strBoardInfo] = $strBoardInfo ; 



	$html_search = "


$strBoardInfo
<table>
<tr><td height='1' ></td></tr>
</table>			

	
<TABLE $attr[width] $attr[bgcolor] >
	<TR $attr[bdcolor] >
		<TD colspan='2' ></TD>
	</TR>

	<form name='search' action='$PHP_SELF?tab=$tab' method='POST' >
	<TR>

		<TD>$htmCategorySelect
		</TD>
		<TD align=right >
		<input type='text' name='keyword' size='12' value='$keyword' >&nbsp;
		<INPUT TYPE='submit' value='˻' class='submit'>&nbsp;

		<select name='order' onchange='submit()'>
		<option value='$order'></option>
		$order_options
		</select>&nbsp;
			
		
		</TD>
	</TR>
	</form>

	<TR $attr[bdcolor] >
		<TD colspan='2' ></TD>
	</TR>
</TABLE>

<table>
<tr><td height='1' ></td></tr>
</table>			
	
	";

$tmpl_html[html_search] = $html_search ; 



}
//mode=search


#mode=interface
{



	if( $_SESSION[sess_uid] > 0  ) {
		$tmpl_html['login'] = "<a href=\"login.html?mode=logoff&url=$PHP_SELF\">{$btn['logoff']}</a>";
		$tmpl_html['user'] = "<a href=\"user.html\">{$btn['member']}</a>";
	} else {
		$tmpl_html['login'] = "<a href=\"login.html?url=$PHP_SELF\">{$btn['login']}</a>";
		$tmpl_html['user'] = "<a href=\"join.html\">{$btn['join']}</a>";
		
	}
	if( $_SESSION[sess_auth] === 1 || ( $board_info[admin] !=="" && $_SESSION[sess_user_id] == $board_info[admin] ) ) {
		$tmpl_html['help'] = "<a href=\"config.html?board_no=$board_no\">{$btn['config']}</a>";
	} else {
		$tmpl_html['help'] = "<a href=\"http://www.grapery.net/gxboard/help.html\" title=\"gxBoard  \" target=\"_blank\">{$btn['help']}</a>";
		
	}



	$user_menu_a['list'] = "<a href='$PHP_SELF?{$gVtab}pnn=$bid&page=$page&$continue'>{$btn['list']}</a>" ; 
	$user_menu_a['view'] = "<a href='$PHP_SELF?{$gVtab}bid=$bid'>{$btn['view']}</a>" ; 
	$user_menu_a['modify'] = "<a href='$PHP_SELF?{$gVtab}mode=write&bid=$bid&vid=$vid'>{$btn['modify']}</a>"; 
	$user_menu_a['delete'] = "<a href='$PHP_SELF?{$gVtab}mode=delete&bid=$bid'>{$btn['delete']}</a>"; 
	$user_menu_a['write'] = "<a href='$PHP_SELF?{$gVtab}mode=write&category_id=$category_id'>{$btn['write']}</a>"; 
	$user_menu_a['reply'] = "<a href='$PHP_SELF?{$gVtab}mode=reply&bid=$bid&vid=$vid'>{$btn['reply']}</a>"; 
	$user_menu_a['recomand'] = "<a href='$PHP_SELF?{$gVtab}bid=$bid&vid=$vid&r=õ'>{$btn['vote']}</a>"; 
	$user_menu_a['back'] = "<a href='javascript:history.go(-1)'>{$btn['back']}</a>" ; 


#	$html_a_href = "<a title=' ϴ.' onClick='alert(\"ȸ޴Դϴ.\\nα ̿밡մϴ.\")'>";
	$html_a_href = "<a title=' ϴ.' >";
	$user_menu_b[modify] = $html_a_href."$btn[mod]</a>"; 
	$user_menu_b["write"] = $html_a_href."$btn[write]</a>"; 
	$user_menu_b[reply] = $html_a_href."$btn[reply]</a>"; 
	$user_menu_b[recomand] = $html_a_href."$btn[vote]</a>"; 
	$user_menu_b["list"] = "<a href='$PHP_SELF?{$gVtab}pnn=$bid&page=$page&$continue'>$btn[list]</a>" ; 
	$user_menu_b[view] = "<a href='$PHP_SELF?{$gVtab}bid=$bid'>$btn[view]</a>" ; 
	$user_menu_b[modify] = ""; 
	$user_menu_b[write] = ""; 
	$user_menu_b[reply] = ""; 





	#echo " : " .
	$lv_auth = $sess_auth + 0 ; 
	#Ѻ



	foreach( $grant_mode_board_keys as $key=>$emode) {

		$is_allow = $gxGRANT[$lv_auth][$emode] ; 
		if( $is_allow > 0 ) {
				$user_menu[$emode] = $user_menu_a[$emode] ; 
			
		} else {
				$user_menu[$emode] = $user_menu_b[$emode] ; 
			
		}
		
	}
	unset($is_allow) ; 



	if ($mode=="write" || $mode=="reply" || $mode=="delete" ) {
		if ($bid) { 
			$a_menu[] = $user_menu['view']; 
		} 
		$a_menu[] = $user_menu['list']; 
		$a_menu[] = $user_menu_a['back']; 
		


	} else { 
		if ($bid) {
			$a_menu[] = $user_menu['list']; 
			$a_menu[] = $user_menu['reply'] ; 
			$a_menu[] = $user_menu['write'] ; 
			$a_menu[] = $user_menu['modify'] ; 
			$a_menu[] = $user_menu['delete'] ; 
			$a_menu[] = $user_menu['recomand'] ; 
		} else {
			$a_menu[] = $user_menu['write'] ; 
			$a_menu[] = $user_menu['admin'];
			$a_menu[] = $user_menu['config'];
			$a_menu[] = $user_menu['login'];
		}
	}

	if (is_array($a_menu)) {
		$user_menu = implode("",$a_menu);
		$tmpl_html[interface] = $user_menu ; 
		$html_interface = $user_menu ;
	}

} //mode=interface




if ( $bid > 0 ) {

	if( $mode=="write") {
		#mode=modify
		gxUnAuthorized($sess_auth,"modify");

		if(gxAuth($sess_auth,"admin")) { // ΰ,  йȣ  .
		} else {
			$wc_user_pass = " and user_pass=password('$pwmodify')";
		}
	}

	$st_view = "select * from $tbl_name where bid=$bid $wc_user_pass";
	$rs_view = mysql_query($st_view);

	if( mysql_num_rows($rs_view) == 0 ) {
		if( $pwmodify ) {
			$err_modify = "<FONT COLOR='#FF3300'>ٽ Է ֽʽÿ.</FONT>";
		} else {
			$err_modify = "йȣ Է ֽʽÿ.";
			
		}


		$modifyform[form] = "
			<FORM METHOD=\"POST\" ACTION=\"$PHP_SELF\">
			<input type=\"hidden\" name=\"bid\" value=\"$bid\">
			<input type=\"hidden\" name=\"mode\" value=\"$mode\">
			<input type=\"hidden\" name=\"tab\" value=\"$tbl_name\">
			
		";
		$modifyform[input_password] = "
			<input type=password name=\"pwmodify\" value=\"$user_pass\" size=16  >
		
		";
		$modifyform[error] = $err_modify ;
		$modifyform[mode] = "" ;

		$tmpl->loadTemplatefile("board_confirm_pw.htm", true, true);

		$tmpl->setCurrentBlock("modify");
		$tmpl->setVariable($modifyform);
		$tmpl->parseCurrentBlock("modify");
		$tmpl->setVariable($tmpl_html) ;
		$tmpl->parse();
		$tmpl->show();

		echo_exit() ; 
	}

	list(
		$bid,
		$ref_bid,
		$category_id,
		$Subject,
		$Date,
		$user_name,
		$user_email,
		$user_id,
		$user_pass,
		$user_agent,
		$remote_addr,
		$hostname,
		$lastModified,
		$lastReply,
		$attach,
		$contents ) = mysql_fetch_row($rs_view);

	$attach = explode( "|" , $attach) ;
 	$ref_bid_array = ref_split($ref_bid);


} else {
	#   ...
		$user_id = $sess_user_id ; 
		$user_name = $sess_alias ; 
		$user_email = $sess_email ; 
}





if( $mode=="delete" && $bid > 0 ) {
	#mode=delete
	gxUnAuthorized($sess_auth,"delete");
	#echo $gxGrant_pwdelete ; 
	if( $pwdelete ) {
		$gxConfig['pwdelete'] = isset($gxConfig['pwdelete']) 
			? $gxConfig['pwdelete'] 
			: "gxboard";
		if( gxAuth($sess_auth,"admin") && $pwdelete == $gxConfig['pwdelete'] ) {
			#ΰ, شԽ йȣ Էϸ ȴ. --;;
		} else {
			$wd_user_pass = "and user_pass=password('$pwdelete')";
		}

		$st_delete = " from $tbl_name where bid=$bid $wd_user_pass ";
		#$st = "select bid " . $st_delete ; 
		#$rs = mysql_query($st) ; 
		#$deleted_rows = mysql_affected_rows() ; 

		$st_delete = "delete" . $st_delete ; 
		$rs = mysql_query($st_delete) ; 
		$deleted_rows = mysql_affected_rows() ; 
	}

	if( $deleted_rows > 0 ) {
		$update_ref_bid = "update $tbl_name set ref_bid = REPLACE(ref_bid,'<$bid>','') where ref_bid rlike '<$bid>' ";
		mysql_query($update_ref_bid) ; 
		#echo mysql_error();		exit;
		echo_replace("$PHP_SELF?page=$page","Ǿϴ.");
		
	} else {


		$deleteform[form] = "
			<FORM METHOD=\"POST\" ACTION=\"$PHP_SELF\">
			<input type=\"hidden\" name=\"bid\" value=\"$bid\">
			<input type=\"hidden\" name=\"page\" value=\"$page\">
			<input type=\"hidden\" name=\"mode\" value=\"$mode\">
			<input type=\"hidden\" name=\"tab\" value=\"$tbl_name\">
			
		";
		$deleteform[input_password] = "
			<input type=\"password\" name=\"pwdelete\" size\"16\" >
		
		";
		$deleteform[error] = "йȣ Է ֽʽÿ." ;

		mysql_data_seek($rs_view,0);
		$tmpl_data = mysql_fetch_array($rs_view);

		$tmpl->loadTemplatefile("board_confirm_pw.htm", true, true);

		$tmpl->setCurrentBlock("delete");
		$tmpl->setVariable($tmpl_data);
		$tmpl->setVariable($deleteform);
		$tmpl->parseCurrentBlock("delete");

		$tmpl->setVariable("mode","") ;
		$tmpl->setVariable($tmpl_html) ;
		$tmpl->parse();
		$tmpl->show();


		
	}

	echo_exit() ; 
}






if ( $mode=="write" or $mode=="reply" ) {
	#mode=write
	gxUnAuthorized($sess_auth,$mode);

	$md5_rand = md5(rand()) ; 
	$_SESSION['md5_rand'] = $md5_rand ; 

	$tmpl->loadTemplatefile("board_write.htm", true, true);

	$tmpl->setVariable( $tmpl_html) ;


	#ũƮ
	#
	$Subject = stripslashes( $Subject );
	$Subject = htmlspecialchars($Subject) ; 
	$user_name = htmlspecialchars($user_name) ; 


	if ($mode == "reply") {

		$replyto = isset($user_email) ? $user_email : "" ; 
		$rs_ref = mysql_query("select ref_bid from $tbl_name where bid=$bid ");
		$ref_bid = mysql_result($rs_ref,0,0);
		$ref_bid .= "<$bid>";
		$bid = "";
		$attach = "";

		$prev_contents = ereg_replace ("<!-- -->","\n\n",$contents);
		$contents = "";

	}	

	$contents = stripslashes( $contents);
	$contents = eregi_replace("<br>", "\n", $contents);

	$contents = explode( "<!-- -->" , $contents) ;


	if ($mode == "reply") {

		$Subject = ereg_replace("\[re:\]","",$Subject);
		$Subject = "[re:]".$Subject;

		$prev_contents = ereg_replace("<br>","\n",$prev_contents) ; 
		$contents[0] = "


<div style=\"color=#606060\">

 $user_name  Դϴ.
 
 $prev_contents

</div>
";

		$mail_fw = "$user_name <$user_email>" ; 

		$user_id = $sess_user_id ; 
		$user_name = $sess_alias ; 
		$user_email = $sess_email ; 
		# $rel_url = $login_rel_url ; 

	} 


	$writeform[form] = "<form enctype=\"multipart/form-data\" name=\"write\" method=\"POST\" ACTION=\"$PHP_SELF\" >";
	$writeform[input_hidden] = "
		<input type=\"hidden\" name=\"tab\" value=\"$tbl_name\" >
		<input type=\"hidden\" name=\"mode\" value=\"$mode\" >
		<input type=\"hidden\" name=\"CERTIFICATION_KEY\" value=\"$md5_rand\" >
	
		<input type=\"hidden\" name=\"bid\" value=\"$bid\" >
		<input type=\"hidden\" name=\"vid\" value=\"$vid\" >
		<input type=\"hidden\" name=\"ref_bid\" value=\"$ref_bid\" >
		<input type=\"hidden\" name=\"user_id\" value=\"$user_id\">
		<input type=\"hidden\" name=\"replyto\" value=\"$replyto\" >
		<input type=\"hidden\" name=\"Date\" value=\"$Date\" >
		<input type=\"hidden\" name=\"lastModified\" value=\"$lastModified\" >
		<input type=\"hidden\" name=\"pwmodify\" value=\"$pwmodify\" >
	";
	$writeform[input_user_name] = "<input type=\"text\" name=\"user_name\" value=\"$user_name\" size=\"16\" >" ; 
	$writeform[input_user_email] = "<input type=\"text\" name=\"user_email\" value=\"$user_email\" size=\"32\" >" ; 
	$writeform[input_Subject] = "<input type=\"text\" name=\"Subject\" value=\"$Subject\" size=\"50\" >" ; 

	$writeform[input_password] = "<input type=\"password\" name=\"user_pass\" value=\"\" size=\"16\" >" ; 
	$writeform[input_submit] = "<input type=submit name=submit value=\"ۼ\" > 
<input type=submit name=submit value=\"÷  ߰\" > " ; 




	$tmpl->setCurrentBlock("write");
	$tmpl->setVariable($tmpl_html) ;
	$tmpl->setVariable($writeform);



#$gxConfig[activeBoardCategory] = 0 ; 
if( $gxConfig[activeBoardCategory] ) {

	$tmpl->setCurrentBlock("category");
	$tmpl->setVariable("htmCategorySelect",$htmCategorySelect);
	$tmpl->setVariable("CategoryPath",$htmCategoryPath);
	$tmpl->setVariable("selectCategory","<select name='category_id'>$category_options</select>");
	$tmpl->setVariable($tmpl_html) ;
	$tmpl->parseCurrentBlock("category");
}



# ݰԽȰ & CP(3) ̻ ϶,
if( $gxConfig[activePayBoard] && $sess_auth > 0 && $sess_auth <=3 ) {

	$input_pay_f = "
		price = <input type=\"text\" name=\"price\" value=\"\" size=\"11\"> 
<BR>unit = <input type=\"text\" name=\"unit\" value=\"\" size=\"11\">(ð) 
<PRE>
nid=auto_increment , 
contents_id = urlencode(\"bid=$bid&tab=$tbl_name&\") , 
contents_uri = \"http://$HTTP_HOST$PHP_SELF\" , 
cp_id=$user_id , 

pay_method ,<select name='pay_method'>$pay_method_options</select> (,б,)
settle_method <select name='settle_method'>$settle_method_options</select> (,ĺ), 
auth_user = <input type=text size=48 >
	(ش ڸ  ִ  ,)

</PRE>

		
	";

	$tmpl->setCurrentBlock("pay");
	$tmpl->setVariable("input_pay",$input_pay_f);
	$tmpl->parseCurrentBlock("pay");


}



while ( list($i,$content) = each($contents) ) {

	if( $i > 0 && $content =="" && $attach[$i]=="" ) {

	} else {
			#ĭ ƴҰ,
		$tmpl_contents['contents'] = "<TEXTAREA NAME='contents[$i]' ROWS=8 COLS=50 >$contents[$i]</TEXTAREA>";
		$tmpl_contents['textarea_contents'] = "<TEXTAREA NAME='contents[$i]' ROWS=8 COLS=50 >$contents[$i]</TEXTAREA>";
		$tmpl_contents['contents_name'] = "contents[$i]";
		$tmpl_contents['contents_value'] = $contents[$i] ;
		


		#$gxConfig[activeFileUpload] = 0 ; 
		if( $gxConfig[activeFileUpload] ) {
			$tmpl_attach['attach'] = "
				<input type='hidden' name='prev_attach[$i]' value='$attach[$i]' >
				<input type='file' name='attach[$i]' value='' size='30' ><BR>$attach[$i]";
			$tmpl_attach['attach_name'] = "attach[$i]";
			$tmpl_attach['attach_value'] = $attach[$i] ;
			$tmpl_attach['attach_hidden'] = "<input type='hidden' name='prev_attach[$i]' value='$attach[$i]' >";

			$tmpl->setCurrentBlock("tr_attach");
			$tmpl->setVariable($tmpl_attach);
			#$tmpl->parseCurrentBlock("tr_attach");

		}

		$tmpl->setCurrentBlock("tr_contents");
		$tmpl->setVariable($tmpl_contents);
		$tmpl->setVariable($tmpl_html) ;
		$tmpl->parseCurrentBlock("tr_contents");
	} 

}













} elseif ( $bid > 0 ) {
	#mode=view



	if($gxConfig[activePayBoard]) {
		#ݰԽ , Լ,
		$contents_id = urlencode("bid=$bid" );
		gxPayContents($contents_id,$sess_user_id,$sess_auth);
	}

	gxUnAuthorized($sess_auth,"view");



#	$attach = implode(" , ",$attach) ; 

	$Subject_abbr = str_abbr($Subject,80);
	$Subject_abbr = htmlspecialchars($Subject_abbr) ; 

	$Subject = wordwrap($Subject,80) ; 
	$Subject = htmlspecialchars($Subject) ; 


	$user_name = htmlspecialchars($user_name) ; 


	$contents = stripslashes( $contents);
	#$contents = eregi_replace("<br>", "\n", $contents);
	$contents = explode( "<!-- -->" , $contents) ;


			$ref_bid_a = ref_split($ref_bid);
			if($ref_bid_a[0] > 0 ) {
				$root_bid = $ref_bid_a[0] ; 
			} else {
				$root_bid = $bid ; 
				
			}



	#/
	if( $vid > -1 )	{
		#mode=view(pnn)

			$pnn_select = "$tbl_name.bid,Subject,DATE_FORMAT(Date,'%m/%d'),user_name  ";

				$prev_vid = $vid -1 ; 
				$next_vid = $vid +1 ; 
				$limit_row = 2 ; 

			if ( $prev_vid < 0 ) {
				$first_vid = 0 ;
				$pnn_list[] = "";
				$pnn_href[] = "<font color=gray>";
				$pnn_vid[] = 1 ; 
			} else {
				$limit_row++ ; 
				$first_vid = $prev_vid ; 
				$pnn_vid[] = $prev_vid ; 
				$pnn_vid[] = $next_vid ; 
			}

			for($i=0 ;  $i < $limit_row ;$i++  ){
				$pnn_vid[] = ++$next_vid ; 
			}



				if (is_array($where)) {
					#echo 
						$temp_where_clause = "WHERE ".implode(" and ",$where);
						$where[] = "$tbl_name.bid != '$bid'";
						if($where["order"]) {
							$no_bid = implode("$|^",$ref_bid_a);
							if( $no_bid ) {
								$where[] = "$tbl_name.bid not rlike '^$no_bid$'";
							}
						}
						$where_clause = "WHERE ".implode(" and ",$where);
				
				} else {
					$where[] = "$tbl_name.bid != '$bid'";
					$where_clause = "WHERE ".implode(" and ",$where);
					
				}



				$limit = "LIMIT $first_vid,$limit_row";
				#echo 
				$prev_next_query = "select $pnn_select from $tbl_name left join {$tbl_name}_count using(bid) $where_clause $order_clause $limit";
				$rs_prev_next = mysql_query($prev_next_query);
				echo mysql_error();


			$i = 0 ; 

			while (list($ppn_bid,$pnnSubject,$pnnDate,$pnnuser_name) = mysql_fetch_row($rs_prev_next)) {
				#$pnn_str[$i]

				$pnntitle = htmlspecialchars("[$pnnDate] $pnnuser_name \n$pnnSubject") ;

				$pnnSubject_abbr = str_abbr($pnnSubject,32);
				$pnnSubject_abbr = htmlspecialchars($pnnSubject_abbr);

				$pnn_href[] = "<a href='$PHP_SELF?bid=$ppn_bid&vid=$pnn_vid[$i]&$continue' title=\"$pnntitle\" >";
				$pnn_list[] = $pnnSubject_abbr ;
				$i++ ; 
			}

		if( $pnn_list[0] ) {
			$prev_contents = "$pnn_href[0] $pnn_list[0]</a> ";
		}
		if( $pnn_list[1] ) {
			$next_contents = " $pnn_href[1]$pnn_list[1]</a> ";
		}
		if( $pnn_list[2] ) {
			$next2_contents = "&nbsp; $pnn_href[2]$pnn_list[2]</a>   ";
		}





		$tmpl_pnn = "$pnn_href[0]$btn[prev]</a></font>$pnn_href[1]$btn[next]</a>";

	} ///













	$Subject = wordwrap($Subject,76 ,"\n",1) ; 
	#$Date=substr($Date,0,10);

	$gxcount = gxBoardCount($bid,$mode) ; 

	#mode=view(IT)
	$tmpl->loadTemplatefile("board_view.htm", true, true);
	$tmpl->setVariable($tmpl_html) ;
	$tmpl->setVariable("pnn_short", $tmpl_pnn) ;
	$tmpl->setVariable("no", $bid) ;
	$tmpl->setVariable("subject", $Subject) ;
	$tmpl->setVariable("name", $user_name) ;
	$tmpl->setVariable("id", $user_id) ;
	$tmpl->setVariable("date", $Date) ;
	$tmpl->setVariable($gxcount) ;

	$tmpl->setCurrentBlock("pnn") ;
	$tmpl->setVariable("prev_contents",$prev_contents) ; 
	$tmpl->setVariable("next_contents",$next_contents) ; 
	$tmpl->setVariable("next2_contents",$next2_contents) ; 
	$tmpl->parseCurrentBlock("pnn") ;









foreach($contents as $key=>$val) {


	if( trim($val) =="" && $attach[$key]=="" ) {
		#echo "<br>$key: ( $attach[$key] ) "; 
	} else {

		$countTag = array(); 
		$countTag = gxCountTag( $val ); 
		#print_r($countTag) ; 
		$startTag = "";
		$endTag = "";
		foreach( $dTag as $i=>$e_tag) {

				$compTagTable = 	$countTag["$e_tag"] -	$countTag["/$e_tag"] ;
				if( $compTagTable < 0  ) {
					$startTag = str_repeat("<$e_tag>",abs($compTagTable) ) . $startTag ;
				} elseif( $compTagTable > 0 ) {
					$endTag .= str_repeat("</$e_tag>",$compTagTable);
				} else {
					
				}

		}

		$val = autoLink($val) ; 
		$val = wordwrap($val,128 ," ",1) ; 
		$img = "";


		if( $attach[$key] ) {
			$attachment = get_attachment($attach[$key],1,$gxConfig[upload_dir]);
			#echo $attachment[filesize] ;
			#var_dump ($attachment) ;

			if($attachment[imagesize] == NULL ) {
				$img = "";
				$attachment[filesize] = number_format( $attachment[filesize] / 1000 ) . "k";
				$attach[$key] = "<BR> &nbsp; &nbsp; ÷ : 
				<a href=\"gxDown.php?bid=$bid&si=$key&tab=$tbl_name\" target=\"_blank\">$attachment[filename] ($attachment[filesize]) </a>";
			
			} elseif( $attachment[imagesize][2] == 4 ) {
				$img =  "<CENTER><OBJECT classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=5,0,0,0\" {$attachment[imagesize][3]} > <PARAM NAME=movie VALUE=\"{$attachment[imguri]}\"> <PARAM NAME=quality VALUE=high> <PARAM NAME=bgcolor VALUE=#FFFFFF> <EMBED src=\"{$attachment[imguri]}\" quality=high bgcolor=#FFFFFF {$attachment[imagesize][3]} TYPE=\"application/x-shockwave-flash\" PLUGINSPAGE=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\"></EMBED> </OBJECT> <BR></CENTER> 
				";
				$attachment[filesize] = number_format( $attachment[filesize] / 1000 ) . "k";
				$attach[$key] = "<BR><div Align=\"center\"> 
				<a href=\"gxDown.php?bid=$bid&si=$key&tab=$tbl_name\" target=\"_blank\">$attachment[filename] ($attachment[filesize]) </a>
				</div><BR>";
			
			} else {

				$filename = $attach[$key] ; 
				$attach[$key] = "";
				if( $attachment[imagesize][0] > 468 ) {
					$image_size = "width=\"468\"";
				} elseif( $attachment[imagesize][1] > 345 ) {
					$image_size = "hieght=\"345\"";
				} else {
					$image_size = $attachment[imagesize][3] ; 
				}
				#$img = "<IMG SRC=\"gxDown.php?bid=$bid&si=$key&tab=$tbl_name\" align=\"left\" $image_size  hspace=\"8\" vspace=\"1\" >";
				#$attachment[imguri] = urlencode($attachment[imguri]) ; 

				$img = "<div align=\"center\"><a href=\"gxDown.php?filename=$filename\" target=\"_blank\"><IMG SRC=\"gxDown.php?filename=$filename\" align=\"center\" $image_size  hspace=\"8\" vspace=\"1\" border=\"0\"></a></div>";

				$img = "<a href=\"$attachment[imguri]\" target=\"_blank\" ><IMG SRC=\"$attachment[imguri]\" $image_size vspace=\"6\" border=\"0\"></a><br>";
				#

			}

	#		$str_attach = basename($attach[$key]) ; 
	#		$attachinfo[basename] = substr( $str_attach , strpos($str_attach,"_") +1 ) ;

		}

	}

	$tmpl->setCurrentBlock("multiple_contents") ;
	$tmpl->setVariable("img", $img) ;
	$tmpl->setVariable("startTag", $startTag) ;
	$tmpl->setVariable("contents", $val) ;
	$tmpl->setVariable("endTag", $endTag) ;
	$tmpl->setVariable("attach", $attach[$key]) ;
	$tmpl->parseCurrentBlock("multiple_contents") ;


}








	{
		#mode=view(ñ۸)
			
		echo "
		<TABLE $attr[table] width='98%' >
		<col $attr[bgcolor] >
		";

				$slc = subListCount($root_bid);
				if ( $slc > 0 ) {
					$iconCollapsed= $LI[expand];
					$sublist = list_tree($root_bid,1);

					$st = "select bid,ref_bid,Subject,DATE_FORMAT(Date,'%m/%d'),user_name,lastReply from $tbl_name where bid='$root_bid'";
					$rs = mysql_query($st);
					list($esl[0],$esl[1],$esl[2],$esl[3],$esl[4],$esl[5]) = mysql_fetch_row($rs);
					$root_bid_list = array( $return_array[] = array($esl[0],$esl[1],$esl[2],$esl[3],$esl[4],$esl[5],"bid"=>$esl[0]), "0" );
					array_unshift ( $sublist , $root_bid_list ); 
					$alt = "alt='$slc  亯 ֽϴ.(ֱٴ亯:$lastReply)'";
					$pnn = $bid ; 
				
					$strSubList = "<ul dynamicoutline noinitcollapsed imagesrc='images/t.gif' style='margin-left : 8pt' align=left >";
					$strSubList .= sublist($sublist,$LI[reduce]);


			$tmpl->setCurrentBlock("reference");
			$tmpl->setVariable("reference_count",$slc);
			$tmpl->setVariable("reference_list",$strSubList);
			$tmpl->setVariable("images",$tmpl_html[images]) ;
			$tmpl->parseCurrentBlock("reference");
				} 

		echo "
		</TABLE>
		";

	//ñ۸
	} 



#echo $html_interface ; 
#echo $html_pnn ; 
#echo $html_search  ; 
#$tmpl->parse() ;

//mode=view
} else {
	#mode=list
	gxUnAuthorized($sess_auth,"list");



	$tmpl->loadTemplatefile("board_list.htm", true, true);




	#echo $html_search  ; 
	if (is_array($where)) {
		foreach ($where as $key => $value ) {
			$where[$key] = stripslashes($value);
		}
		$where_clause = "WHERE ".implode(" and ",$where);
	}

	$count_num_que = mysql_query ("select count(bid) , max(bid) from $tbl_name $where_clause " );
	$count_num_rows = @mysql_result($count_num_que,0,0);
	if( $error = mysql_error() ) {

		echo "<p align=center style=\"line-height:150%\"> ";
		echo "<br>̺ '$tbl_name'    ʽϴ. <BR> , ̺ Ͽ ֽʽÿ.<BR>(";
		echo $error ; 
		echo ")";

		#mode=create_table_form
		include ( 'gx/board/create_table.php');


		echo_exit();

	}

	if ( !$page_term  ) $page_term = 10 ;
	$first = $page * $page_term;
	$limit = " LIMIT $first , $page_term ";
	$vid = $first ; 


	if( $mode=="notice") {
		$tmpl->setCurrentBlock("notice");
		$st_notice = "select Subject,Date,contents from $tbl_name $where_clause $order_clause limit 1 ";
		$rs_notice = mysql_query($st_notice);
		$notice_Variable = mysql_fetch_array($rs_notice);

		$tmpl->setVariable( $notice_Variable) ;
		$tmpl->parseCurrentBlock("notice");
	}

	$tmpl->setCurrentBlock("list");



	$st_list = "select lst.bid,ref_bid,Subject,DATE_FORMAT(Date,'%m/%d'),user_name,lastReply,category_id 
		, view , recommand , download , paycount, last
		from $tbl_name as lst LEFT JOIN {$tbl_name}_count as cnt USING( bid )
		$where_clause $order_clause $limit ";
	$rs_list = mysql_query($st_list);
	echo mysql_error();




	# style='margin-left : 0pt'
	#<ul dynamicoutline initcollapsed imagesrc='images/t.gif' style='margin-left : 8pt'>



	$gxAuth = gxAuth($lv_auth,"view") ; 

	while ( list($bid,$ref_bid,$Subject,$Date,$user_name,$lastReply,$category_id
		,$_count[view],$_count[recommand],$_count[download],$_count[paycount],$_count[last]) = mysql_fetch_row($rs_list)) 
	{

		if ( $category_id > 0  ) {
			$strCategory = "[".$arrCategory[$category_id]."]" ; 
		} else {
			$strCategory = "";
		}
		$Subject = htmlspecialchars($Subject) ; 
		$subj_abbr = str_abbr("$Subject",$abbr_size,"..");

		$user_name = htmlspecialchars($user_name) ; 
		$user_name = str_abbr($user_name,8,"..");


		$slc = subListCount($bid);
		$subAticle = "";
		if ( $slc > 0 ) {
			$sublist = list_tree($bid,0);
#			print_r($sublist);
			foreach( $sublist as $key=>$val) {
				$subAticle .= '<'.$val[0][0].'>';
				#print_r($val[0][0]);
			}
			$iconCollapsed = $LI[expand]; //$str_expand;
			$alt = "alt='$slc  亯 ֽϴ.(ֱٴ亯:$lastReply)'";
			$iconCollapsed = str_replace( ">"," onclick=dynOutline(this) $alt >" , $iconCollapsed )  ;
		} else {
			$iconCollapsed= $LI[reduce]; //$str_reduce;
			$alt = "";
		}

		#echo "<br>ereg(\"<$pnn>\",$subAticle)";
		if( $bid==$pnn or ( $pnn > 0 and ereg("<$pnn>",$subAticle) )  ) {

			#  ִ ,

			$FolderIcon = $LI["open"];
			$initcollapsed = "";
			$img_collapsed = $LI[reduce]; //$str_expand;
			$alt = "alt='$slc  亯 ֽϴ.(ֱٴ亯:$lastReply)'";
			$iconCollapsed = str_replace( ">"," onclick=dynOutline(this) $alt >" , $img_collapsed )  ;
					
		} else {

			#  ִ ,

			$FolderIcon = $LI["close"];
			$initcollapsed = "initcollapsed";
			$img_collapsed = $LI[expand];
		}



		if( $where["order"] ) {
			#$str_e = str_replace( ">"," onclick=dynOutline(this) $alt >" , $img_collapsed )  ;
		} else {
			$iconCollapsed = "";
		}

		if( $gxAuth === true ) {
			$a_href = "<a href='$PHP_SELF?bid=$bid&vid=$vid&$continue' title=\"$strCategory\n$Subject($bid)\">";
		} else {
			$a_href = "<a title=\"$Subject($bid)\">";
			
		}


		$subj_abbr = wordwrap($subj_abbr,80 ,"\n",1) ; 
		$Subject = wordwrap($Subject,80 ,"\n",1) ; 

		$strSubject = "
			<ul dynamicoutline $initcollapsed 
				style='margin-bottom:0pt ; margin-left : 34pt ; text-indent : -32pt '>
				<li>$iconCollapsed$FolderIcon $a_href
					$subj_abbr</a>
				</li>
		";



		if( $where["order"] ) {
		if ( is_array($sublist) ) {
		if( $tmpl->blocklist[sublistIcon] ) {

			foreach($sublist as $esl) {

				if ($esl[1] =="last") {
				} else {
						
					list($subbid,$subref_bid,$subSubject,$subDate,$subuser_name,$sublastReply) = $esl[0] ; 

					$slc = subListCount($bid,1);

					if ( $slc > 0 ) {
						$iconCollapsed= $imagesrc ; //$LI[expand or reduce]
						$alt = "alt='亯 ֽϴ.(ֱٴ亯:$lastReply)'";
						$iconCollapsed = str_replace( ">"," onclick=dynOutline(this) $alt >" , $iconCollapsed )  ;
					} else {
						$iconCollapsed= $LI[last]; // ̻ Խù .
						$alt = "";
					}

					if( $subbid > 0 ) {

						$FolderIcon = ($bid==$pnn) ? $LI["open"] : $LI["close"] ; 

						$subuser_abbr = str_abbr($subuser_name,6,"..") ; 
						$subsubj_abbr = str_abbr($subSubject,$abbr_size - $esl[1] ,"..");
						$subsubj_abbr = htmlspecialchars($subsubj_abbr) ; 
						#$user_name = htmlspecialchars($user_name) ; 
						$subsubj_abbr = wordwrap($subsubj_abbr,80 ,"\n",1) ; 
						$subSubject = wordwrap($subSubject,80 ,"\n",1) ; 
						$subtitle = htmlspecialchars("ۼ: $subDate , ۼ: $subuser_name\n$subSubject");

						$ListIcon = "<li>$iconCollapsed$FolderIcon";

						$tmpl->setCurrentBlock("sublist") ;
						$tmpl->setVariable("href", "$PHP_SELF?bid=$bid&vid=$vid&$continue" ) ;
						$tmpl->setVariable("title", $subtitle ) ;
						$tmpl->setVariable("user_name", $subuser_name ) ;
						$tmpl->setVariable("user_abbr", $subuser_abbr ) ;
						$tmpl->setVariable("Subject", $subSubject ) ;
						$tmpl->setVariable("subj_abbr", $subsubj_abbr ) ;
						$tmpl->setVariable("Date", $subDate ) ;
						#$tmpl->setVariable("subject", $strSubject ) ;
						$tmpl->parseCurrentBlock("sublist") ;

					} else {
						$ListIcon = $subSubject ;
					}



				}


				$tmpl->setCurrentBlock("sublistIcon") ;
				$tmpl->setVariable("ListIcon", $ListIcon ) ;
				$tmpl->parseCurrentBlock("sublistIcon") ;


			} //foreach

		} else {
			# $tmpl->blocklist[data_row_Subject]   ,
			$strSubject .= sublist($sublist,$img_collapsed);
			$strSubject .= "</ul>";
			
		}
		} //if ( is_array($sublist) ) 
		} //if( $where["order"] ) 

		#echo $strSubject ; 
		$vid++;


		$tmpl->setCurrentBlock("data_row") ;
		$tmpl->setVariable("no", $bid) ;
		$tmpl->setVariable("subject", $strSubject ) ;
		$tmpl->setVariable("name", $user_name) ;
		$tmpl->setVariable("date", $Date) ;
		$tmpl->setVariable($_count) ;
		$tmpl->setVariable($tmpl_html) ;
		$tmpl->parseCurrentBlock("data_row") ;

	
	} //while...


	$html_pagelist = pagelist($count_num_rows,"˻ Խù  ʽϴ.");


	if( $gxConfig[activeBoardCategory] ) {

		$tmpl->setCurrentBlock("category");
		$tmpl->setVariable("htmCategorySelect",$htmCategorySelect);
		$tmpl->setVariable("htmCategoryPath",$htmCategoryPath);
		$tmpl->setVariable("category_options",$category_options);
		$tmpl->setVariable("selectCategory","<select name='category_id'>$category_options</select>");
		$tmpl->setVariable("images",$tmpl_html[images]) ;
		$tmpl->parseCurrentBlock("category");
	}

	$tmpl->setCurrentBlock("list");
	$tmpl->setVariable( $tmpl_html ) ;
	$tmpl->parseCurrentBlock("list");
	$tmpl->setVariable("pagelist",$html_pagelist) ; 


//mode=list

}

$tmpl->setVariable( $tmpl_html ) ;
$tmpl->parse();
$tmpl->show();



if( $gxConfig[tmpl_debug] == 1 ) {
	echo "<BR><BR><TEXTAREA ROWS=16 COLS=80 >";

	$tmpl_debug[fileRoot] = $tmpl->fileRoot ; 
	$tmpl_debug[lastTemplatefile] = $tmpl->lastTemplatefile ; 
	$tmpl_debug[variableCache] = array_keys($tmpl->variableCache) ;
	$tmpl_debug[blockvariables] = $tmpl->blockvariables ; 

	print_r($tmpl_debug) ; 

	echo "</TEXTAREA>";
}

?>


<!-- End of gxBoard -->


