<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | gxBoard                                                              |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 gxBoard.co.kr                                     |
// +----------------------------------------------------------------------+
// | This source file is subject to The gxBoard License,                  |
// | that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at                           |
// | http://gxboard.co.kr/license/LICENSE.txt.                            |
// | If you did not receive a copy of the gxBoard license and are unable  |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@gxboard.co.kr so we can mail you a copy immediately.         |
// +----------------------------------------------------------------------+
// | Author: Kiwha Um <xhunter@gxboard.co.kr>                             |
// +----------------------------------------------------------------------+
//
// $Id: gxfunctions.php,v 1.0 2002/12/06 17:56:10 xhunter Exp $

require_once ( 'gx/lib/gxfunction_cvs_only.php');

function autoLink($str) { 
// link all urls and email ( and news:// , ~ support userdirectory ) -  2001 6 26 ȭ  9:05:25 
    $str2 = preg_replace("/(?<!<a href=\")(?<!\")(?<!\">)((http|https|ftp|news):\/\/[%~\w?=&.\/-]+)/","<a href=\"\\1\" target='_blank'>\\1</a>",$str); 
    $str2 = preg_replace("/((?<!<a href=\"mailto:)(?<!\">)(?<=(>|\s))[\w_-]+@[\w_.-]+[\w]+)/","<a href=\"mailto:\\1\">\\1</a>",$str2);    return $str2; 
}

function autoEmbeded($str) {
		Return $str ;
}


function str_abbr($msg,$cut_size,$adddot="...") {

	#$msg = ereg_replace("<[^<]*>","",$msg); // ± --;;
	$msg = ereg_replace("red","#C95B36",$msg); // ϴ ,

	if( strlen($msg) < $cut_size ) {
		Return $msg ;
	}


	if ( ereg("<b>",$msg) ) 	$cut_size_pp = 0 - floor($cut_size/4) ;
	else 	$cut_size_pp = 0 ; 

	$i_indicatorL = 0; 
	$i_indicatorR = 0; 
	while( is_int(($i_indicatorL=strpos($msg,"<",$i_indicatorR))) ) {
		// Get everything into tag... 
		$i_indicatorL++; 
		$i_indicatorR = strpos($msg,">", $i_indicatorL); 
			if( $i_indicatorR > 0 ) {			
			} else {
				break ; 
			}
		$cut_size_pp += $i_indicatorR-$i_indicatorL + 2 ; 
	} 
 
	if($cut_size<=0) return $msg; 
	
	for($i=0;$i<$cut_size;$i++) {
		if(ord($msg[$i])>127) $han++; 
		else $eng++; 
	}

	$cut_size=$cut_size+(int)$han*0.5 ; 
	$cut_size += $cut_size_pp; 

	$point=1; 

	if( strlen($msg) < $cut_size ) {
		Return $msg ;
	}

	
	for ( $i=0 ; $i < strlen($msg) ; $i++ ) { 

		if ( $point > $cut_size ) {						return $pointtmp.$adddot;		} 

		if ( ord($msg[$i]) <= 127 ) 	{ 
			$pointtmp.= $msg[$i]; 
			if ( $point%$cut_size==0 ) {				return $pointtmp.$adddot; 			}

		} else 	{ 
				if ( $point%$cut_size==0 ) { 					return $pointtmp.$adddot; 				} 
				$pointtmp.=$msg[$i].$msg[++$i]; 
				$point++; 

		} 
		$point++; 
	} 
	return $pointtmp; 

} //str_abbr 


function gxBoardCount($bid,$mode="view") {
	Global $tbl_name_count , $REMOTE_ADDR , $sess_user_id ; 
	if( $mode=="") {
		$mode="view" ; 
	}

	if( $sess_user_id ) {
		$access_user = urlencode($sess_user_id);
		$where_user = "and access_user not rlike '=$access_user&'";
	}
	$update = "update $tbl_name_count set 
			$mode=$mode+1 ,
			last=now(), 
			remote_ip=CONCAT('<$REMOTE_ADDR>',remote_ip),
			access_user=CONCAT('u[]=$access_user&',access_user)
			WHERE bid=$bid 
				and ( remote_ip not rlike '<$REMOTE_ADDR>' $where_user )
		";
		// or  Ұ, ٸ ̵ 쿡 ȸ  .

	mysql_query($update);
	#echo mysql_error();


	$st = "select view,recommand,download,paycount from $tbl_name_count where bid=$bid";
	$rs = mysql_query($st);
	$cnt = mysql_fetch_array($rs) ; 

	if($cnt) {
		$cnt[strCount] = "<TABLE width=\"98%\" border='0' cellpadding='0' cellspacing='0' ><TR><TD align=right>
		[ ȸ:$cnt[view] / õ:$cnt[recommand] / ٿ:$cnt[download] / :$cnt[paycount] ] 
		&nbsp; </TD></TR></TABLE>";
	}

	Return $cnt ;
}


############
## gxboard ԽǱѰ Լ

#׷쿡   

function gxAuth( $lv,$mode,$pay="0" ) {
	Global $gxGRANT ; 
	$lv = $lv +0 ;

	if( $gxGRANT[$lv][$mode] > 0  ) {
		Return true;
	} else {
		Return false ;
	}
}


function gxUnAuthorized($lv,$mode,$pay="0") {
	Global $opt_auth_lv ,$gxGRANT , $gx_ini ,$gxConfig , $tmpl_html , $tmpl ; 



	$lv = $lv +0 ;
	if( gxAuth($lv,$mode,$pay)  ) {
		Return true;
	} else {
			
		$string = "
			 ϴ.[ mode=$mode , Lv=$lv;$opt_auth_lv[$lv] ]
			";
			#foreach( $gxGRANT[$lv] as $key=>$val) {
			#	$string .= "$key=$val , \n"; 
			#}

		$tmpl->loadTemplatefile("error.htm", true, true );
		$tmpl->setVariable( "error_msg",$string ) ;
		$tmpl->setVariable( $tmpl_html  ) ;
		$tmpl->setVariable( $gx_ini	  ) ;
		$tmpl->show() ;

		if( $tmpl->blockvariables[__global__][error_msg]  ) {
			#print_r($tmpl->blockvariables );
		} else {
			echo "<pre>".$string."</pre>" ; 
			
		}

		echo_exit();

	}

	
}



function gxGrant( $auth_level="0" , 
					$GrantMode="" , 
					$GrantTab="" , 
					$admin="" , $user="" ) {

	global $gxGrant_mode_board , $insert_value ; 
	
	if( $GrantMode == "") {
		$GrantMode = $gxGrant_mode_board  ; 
	}
	if( $GrantTab == "") {
		$GrantTab = unserialize($insert_value[grant_table]) ; 
	}
	if( $user == "" ) { 
		$user = "guest"	; 
	}

	if( !is_array($GrantMode) ) {
		$GrantMode = explode("|",$GrantMode);
	}

	if( !is_array($GrantTab)) {
		parse_str($GrantTab,$GrantTab) ; 
	} 

	if( $admin && $user == $admin ) {
		$auth_level = 1 ; 
	} else {
		$auth_level = $auth_level + 0 ; 
	}

	$gxGrant[$auth_level] = array();
	foreach( $GrantMode as $i => $grant_mode ) {
		$gxGrant[$auth_level][$grant_mode] = $GrantTab[$auth_level][$i];
	}
	Return $gxGrant  ;

}



function cfgtr($array,$skin="") {
	if( $skin=="") {
		$images = ".";
	} else {
		$images = $skin;
		
	}
	if( is_array($array) ) {
		foreach( $array as $key=>$val) {
			$array[$key] = stripslashes($array[$key])  ; 
			$array[$key] = str_replace("{images}",$images,$array[$key]);
			$array[$key] = str_replace("{key}",$key,$array[$key]);
			$array[$key] = str_replace("%key%",$key,$array[$key]);
			$array[$key] = str_replace("%skin%",$skin,$array[$key]);
		}
	}
	Return $array ;
}

function get_mimetype($imagesize) {
	
	if( $imagesize == NULL ) {
		$mimetype = "application/octet-stream";
	} else {

		$mime_type[1] = "image/gif";
		$mime_type[2] = "image/jpeg";
		$mime_type[3] = "image/png";
		$mime_type[4] = "application/x-shockwave-flash";
		$mime_type[5] = "application/x-adobe-photoshop-image";
		$mime_type[6] = "image/bmp";
		$mime_type[7] = "image/tiff";
		$mime_type[8] = "image/tiff";
		$mime_type[9] = "application/octet-stream";
		$mime_type[10] = "application/octet-stream";
		$mime_type[11] = "application/octet-stream";
		$mime_type[12] = "application/octet-stream";
		$mime_type[13] = "application/octet-stream";
		$mime_type[14] = "application/octet-stream";
		$mimetype = $mime_type[$imagesize[2]] ;
	}
	Return $mimetype ;
}

function get_attachment($attach,$position=0,$dir="") {

	$attachment[imguri] = $dir.$attach ; 
	$attachment[filesize]	= @filesize($dir.$attach);
	$attachment[imagesize]	= @getimagesize($dir.$attach);
	$attachment[mimetype]	= get_mimetype($attachment[imagesize]);

	$attachment[filename] = basename($attach) ; 

	if( $position > 0 ) {
		$attachment[filename] = substr( $attachment[filename] , strpos($attachment[filename],"_") +$position ) ;
	}

	Return $attachment ;
}

function gxDownload($filename,$mimetype="",$dir="./upload/") {


	$att = get_attachment($filename,1,$dir) ; 
	#print_r($att);	exit();
	if( $att[filesize] > 0  ) {
		header("Content-type: $att[mimetype] ");
		header("Content-Disposition: attachment; filename=$att[filename]");
		readfile("$att[imguri]");
	} else {
		echo " ã  ϴ.
		<br>( File not found! ) ";
	}
	
}


function gxMultiFileUpload($attach,$attach_name,$previous,$tbl_name,$aid,$dir="upload") {

	$aid = str_pad($aid,3,"0",STR_PAD_RIGHT);

	if ( !is_dir("$dir")) {
		mkdir("$dir",0777) || die("  ͸( $dir )  ʰų,   ϴ.( $dir )");
	}

	$attach_path = date("Ym") ; 
	if ( !is_dir("$dir/$attach_path")) {
		mkdir("$dir/$attach_path",0777) || die("͸  .($attach_path)");
	}
	$attach_path .= "/$tbl_name" ; 
	if ( !is_dir("$dir/$attach_path")) {
		mkdir("$dir/$attach_path",0777) || die("͸  .($attach_path)");
	}

	while( list( $i,$tmp )=each($attach)) {

		if(  $attach_name[$i]=="delete" || $attach_name[$i]=="" ) {

			if ($previous[$i]) {
					if( unlink("$dir/$previous[$i]") ) {
					}  else {
						echo "<script>alert('  : $dir/$previous[$i] ')</script>";
					}
			}
			$update_attach[$i] = ""	; 

		}	elseif( is_uploaded_file($tmp) ) {

			$update_attach[$i] = "$attach_path/".$aid.$i."_".$attach_name[$i] ; 
			move_uploaded_file ($tmp, "$dir/$update_attach[$i]" ) || die("<PRE>failed to copy
$dir/$update_attach[$i]
\$dir = $dir
\$attach_path = $attach_path
\$update_attach = $update_attach[$i]
</PRE>");

			if ($previous[$i]) {
					if( unlink("$dir/$previous[$i]") ) {
					}  else {
						echo "<script>alert('  : $dir/$previous[$i] ')</script>";
					}
			}


		} else {
			$update_attach[$i] = $previous[$i]	; 
			
		}
		
	}

	$update_attach = implode("|",$update_attach);
	return $update_attach ; 

} //function gxMultiFileUpload




function implodeMailHeader($headers)
{
	foreach ($headers as $key => $val) {
		if ($key == 'subject') {
				$Subject = $val ;
				#$xtra_headers .= $key . ': ' . $val . "\n";
				// mailԼ  ó.
		} else if ($key == 'Received') {
				// put Received: headers at the top, since Receieved:
				// after Subject: in the header order is somtimes used
				// as a spam trap.
				$xtra_headers = $key . ': ' . $val . "\n" . $text_headers;
		} else {
				$xtra_headers .= $key . ': ' . $val . "\n";
		}
	}

	return  $xtra_headers ;
}


function make_htmlBody($tmpl,$replace_pairs) {
	$msg = implode ('', file ($tmpl));
	$msg = strtr($msg,$replace_pairs);
	Return $msg ;
}


function gxSendMail($to,$Subject,$body_html,$from,$cid=array(),$attachment=array()) {
	/*
	gxSendMail() - 2002 10 11 ݿ
	ϱ  Ʊ Լ Դϴ.
	 gxUser-ȸԺκ̳ gxBoard ۼ κ  Ͻʽÿ.

	$to : 	޴»
	$Subject : 
	$body_html : Ϻ(HTML)
	$from : »
	$cid : Ͽ ÷ε ̹
	$attachment : ÷
	*/
	# Mail_mimePart Ŭ .(PEAR)
	require_once ('Mail/mimePart.php'); 

#	$from = 

	$body_text = strip_tags($body_html);
	$xtra_headers = "From:$from\r\n";
	$xtra_headers .= "MIME-Version: 1.0\r\n";


	$params['content_type'] = "multipart/mixed";
	$mimePart = new Mail_mimePart('', $params);
	{

		//*
		#alt
		$params['content_type'] = "multipart/related;\r\n\ttype=\"multipart/alternative\"";
		$related =& $mimePart->addSubPart('',$params);
		{
			$params['content_type'] = 'multipart/alternative';
			$alt =& $related->addSubPart('',$params);
			{
				#ؽƮ
				$params['content_type'] = 'text/plain';
				$params['encoding']     = '7bit';
				$alt->addSubPart($body_text, $params);

				#html
				$params['content_type'] = 'text/html';
				$params['encoding']     = 'base64';
				$alt->addSubPart($body_html, $params);
			}

			#html  ̹.
			foreach( $cid as $key=>$val) {

				$att = get_attachment($val) ; 
					$mimetype = $att[mimetype] ;	
					$filename = $att[filename] ;
				$fd = @fopen ($val, "rb");	
				if( $fd ) {
				$file = fread ($fd, filesize ($val));
				fclose ($fd); 

				$params['content_type'] = $mimetype;
				$params['dfilename']    = $filename ;
				$params['encoding']     = 'base64';
				$params['disposition']  = 'attachment';
				$params['cid']			= $key ;
				#$params['Content-Location'] = $val ;
				$related->addSubPart($file, $params);
				}
				
			}
			

		} //related

		#÷
		foreach( $attachment as $key=>$val) {

			$att = get_attachment($val) ; 
				$mimetype = $att[mimetype] ;	
				$filename = $att[filename] ;
			$fd = @fopen ($val, "rb");	
			if( $fd ) {

			$file = fread ($fd, filesize ($val));
			fclose ($fd); 

			$params['content_type'] = $mimetype;
			$params['dfilename']    = $filename ;
			$params['encoding']     = 'base64';
			$params['disposition']  = 'attachment';
			$params['cid']			= $key ;
			$mimePart->addSubPart($file,$params);
			}
		}

	} //mimePart

	$mimePart = $mimePart->encode() ; 
	$xtra_headers .= implodeMailHeader( $mimePart[headers] ) ;
	$mail_body = $mimePart[body] ; 


	if( $to ) {
		mail($to,$Subject,$mail_body,$xtra_headers);
		Return true ;

	} elseif($from) {
		mail($from,$Subject,$mail_body,$xtra_headers);
		Return true ;
	} else {
		echo "Bad Message destination ( (޴)   ʾҽϴ. )";
		Return false ;
	}
	
} // gxSendMail()





function pagelist($total,$no_result="˻ ڷᰡ ϴ.") {
	Global $continue , $page ,  $page_term ; 
	if( $page_term > 0 ) {
	} else {
		$page_term = 10 ; 
	}

	if ($total < 1 ) { 
		$strPagelist .=  $no_result; 

	} elseif ($total <= $page_term ) {

	}	else {
		$p = floor($page /10 )*10;
		$page_f = $p -1 ; 
		$page_l = $p +10 ;

		if ( $page_f >= 0 ) {
			$strPagelist .= "<a href='$PHP_SELF?$continue&page=$page_f' class='page'>[prev]</a> " ;
		} else { 
			$strPagelist .= "";
		}

		while ( $p < $page_l  ) {
			$strPagelist .= "<a href='$PHP_SELF?$continue&page=$p' class='page'>";
			if ($p == $page) $strPagelist .= "<b>";
			$p++;
			$strPagelist .= "[$p]</b></a> " ;
			if ( $p * $page_term >= $total ) { break ; }
			if ( $p != $page_l ) echo "";
		}

		if ( $page_l * $page_term < $total )
			$strPagelist .= " <a href='$PHP_SELF?$continue&page=$page_l' class='page'>[next]</a>" ;
		else $strPagelist .= "";

	}	
	Return $strPagelist ;
}




function echo_replace($url,$alert="") {
	if($alert !="" ) {
		$alert = htmlspecialchars($alert); 
		$script_alert = "alert(\"$alert\") ; ";
	}
	echo "
	<script>	
		$script_alert
		location.replace(\"$url\") ; 
	</script>	
	";
	
}


function echo_exit($str="",$e=false) {
	global $gxConfig , $include_file ; 
	if( $str ) {
		echo $str ; 
	} else {
			$e=true ; 
		if( $include_file[htmFoot]  ) {
			include ( $include_file[htmFoot] );
		} elseif( $gxConfig[strExit]) {
			echo $gxConfig[strExit] ; 
		} else {
			include ("_exit.php");
		}
	
	}
	if( $e==true ) { 
		exit();	
	}
} //echo_exit("",1);



?>