<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | gxBoard                                                              |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 gxBoard.co.kr                                     |
// +----------------------------------------------------------------------+
// | This source file is subject to The gxBoard License,                  |
// | that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at                           |
// | http://gxboard.co.kr/license/LICENSE.txt.                            |
// | If you did not receive a copy of the gxBoard license and are unable  |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@gxboard.co.kr so we can mail you a copy immediately.         |
// +----------------------------------------------------------------------+
// | Author: Kiwha Um <xhunter@gxboard.co.kr>                             |
// +----------------------------------------------------------------------+
//
// $Id: gxUser_search.php,v 1.0 2002/11/27 23:37:12 xhunter Exp $
//
// 
//

#mode=searchForm
{

	# $keyword,$gid , $auth , $name , $jnum  , $sex , $hidden , $birthday

	if ($keyword) {
		$get_vars[keyword] = "keyword=$keyword";
		$where[] = "( company rlike '$keyword' 
		or title rlike '$keyword' 
		or department rlike '$keyword'
		or assistant rlike '$keyword'
		or notes rlike '$keyword'
		)";

	} else {

	}


	if( is_numeric($gid)  ) {
		$get_vars[gid] = "gid=$gid";
		$where[] = "gid='$gid'";

	}

	if( is_numeric($auth) ) {
		$get_vars[auth] = "auth=$auth";
		$where[] = "auth_lv='$auth'";

	}


	if( $name) {
		$get_vars[name] = "name=$name";
		$where[] = "( user_name rlike '$name' or user.user_id rlike '$name' or user.user_alias like '$name%')";

	}


	if( $jnum ) {
		$get_vars[jnum] = "jnum=$jnum";
		$where[] = "jnum rlike '$jnum'";
	}

	if( $sex ) {
		$get_vars[sex] = "sex=$sex";
		$where[] = "sex='$sex'";
	}

	if( $hidden) {
		$get_vars[hidden] = "hidden=$hidden";
		$where[] = "hidden='$hidden'";
	}

	if( $birthday) {
		$get_vars[birthday] = "birthday=$birthday";
		$where[] = "birthday='$birthday'";
	}



	if (is_array($where)) {
		foreach ($where as $key => $value ) {
			$where[$key] = stripslashes($value);
		}

		$where_clause = "WHERE ".implode(" and ",$where);
		reset($where) ; 
	}

	if ($order) {
		$get_vars[order] = "order=$order";

	} else {
		$where["order"] = "ref_bid like ''";
	
	}
	
	$opt_order[""] = "ORDER BY lastModified desc"; 
	$opt_order[""] = "ORDER BY bid desc "; 
	$opt_order[""] = "ORDER BY subject"; 
	$opt_order["ȸ"] = "ORDER BY view desc , bid desc"; 
	$opt_order["õ"] = "ORDER BY recommand desc, bid desc"; 
	$opt_order["ٿ"] = "ORDER BY download desc, bid desc"; 
	$opt_order[""] = "ORDER BY paycount desc, bid desc"; 
	$opt_order["ֱ"] = "ORDER BY last desc, bid desc"; 
	$opt_order[""] = "ORDER BY user.uid desc"; 

	foreach( $opt_order as $key=>$val) {
		$order_options .= "<option>$key</option>"; 
		
	}

	$order_clause = $opt_order["$order"];


	if ( is_array($get_vars) ) {
		$continue = implode("&",$get_vars);
	}


	# $keyword,$gid , $auth , $name , $jnum  , $sex , $hidden , $birthday

$search_form['form_addressbook'] = "
	<form name=\"addressbook\" action=\"$PHP_SELF\" method=\"POST\" >	";

$search_form['select_gid'] = "
	<select name=\"gid\">
	<option value=\"$gid\">$opt_gid[$gid]</option>
	$gid_options
	<option></option>
	</select>	";
$search_form['select_auth'] = "
	<select name=\"auth\">
	<option value=\"$auth\">$opt_auth[$auth]</option>
	$auth_options
	<option></option>
	</select>	";
$search_form['select_sex'] = "
	<select name=\"sex\">
	<option value=\"$sex\">$opt_sex[$sex]</option>
	$sex_options
	<option></option>
	</select>	";

$opt_hidden[0] = "";
$opt_hidden[1] = "";

$search_form['select_hidden']  = "
	<select name=\"hidden\">
	<option value=\"$hidden\">$opt_hidden[$hidden]</option>
	<option value=\"0\"></option>
	<option value=\"1\"></option>
	</select>	";

$search_form['input_keyword'] = "<input name=\"keyword\" value=\"$keyword\" size=\"16\">";
$search_form['input_name'] = "<input name=\"name\" value=\"$name\" size=\"16\">";
$search_form['input_jnum']  = "<input name=\"jnum\" value=\"$jnum\" size=\"14\">";
$search_form['input_birthday']  = "<input name=\"birthday\" value=\"$birthday\" size=\"8\">";

$search_form['submit']  = "<input type=\"submit\" name=\"submit\" value=\"˻\">";
$search_form['images']  = $gx_ini['images'];
#$search_form['skin']  = $config[skin]; //d/
$search_form['PHP_SELF']  = $PHP_SELF ;


}
?>