<?
/*
(PHP 4 CVS only)
2002-08-30 


*/

if (!function_exists('file_get_contents')) {
	/*
	file_get_contents -- Reads entire file into a string
	Description
	string file_get_contents ( string filename [, int use_include_path])

	Identical to readfile(), except that file_get_contents() returns the file in a string. 
	Note: This function is binary-safe.
	Tip: You can use a URL as a filename with this function if the "fopen wrappers" have been enabled. See fopen() for more details.
	*/
	function file_get_contents($filename,$use_include_path=false) {

		$fd = @fopen($filename,'r',$use_include_path) ; 
		if( $fd) {
			$string = fread($fd,filesize($filename));
			fclose ($fd);
			Return $string ;
		} else {
			echo "No such file or directory - $filename " ;
		}
	}
}




?>