<?php
/* vim: set expandtab tabstop=4 shiftwidth=4: */
// +----------------------------------------------------------------------+
// | gxBoard                                                              |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002 gxBoard.co.kr                                     |
// +----------------------------------------------------------------------+
// | This source file is subject to The gxBoard License,                  |
// | that is bundled with this package in the file LICENSE, and is        |
// | available at through the world-wide-web at                           |
// | http://gxboard.co.kr/license/LICENSE.txt.                            |
// | If you did not receive a copy of the gxBoard license and are unable  |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@gxboard.co.kr so we can mail you a copy immediately.         |
// +----------------------------------------------------------------------+
// | Author: Kiwha Um <xhunter@gxboard.co.kr>                             |
// +----------------------------------------------------------------------+
//
// $Id: gxExportFile.php,v 1.0 2002/12/12 4:44:07 xhunter Exp $


function gxExportFile($contents,$filename,$mimetype="") {

	header("Content-Disposition: attachment; filename=$filename");

	if( $mimetype=="" ) {
		header("Content-type: application/octet-stream ");
	} else {
		header("Content-type: $mimetype ");
	}

	print($contents) ; 
}

if( $contents && $filename ) {
	$contents = stripslashes($contents);
	gxExportFile($contents,$filename,$mimetype);
} else {
	echo " : gxExportFile(\$contents,\$filename,\$mimetype);";
}


?>